#include "KpDCPwr.h"
#include <stdlib.h>
#include <stdio.h>
#include <userint.h>
#include "KpDCPwrErrorHandler.h"


void ErrorHandler(ViSession vi)   
{
   ViChar *buffer = VI_NULL;
   ViChar *pos = VI_NULL;
   ViStatus errorCode = VI_SUCCESS;
   ViInt32 bufferSize = 0;
   bufferSize = KpDCPwr_GetError(vi, &errorCode, 0, buffer);
   //  the additional 256 bytes are for the static text before the description.
   pos = buffer = malloc(bufferSize + 256);
   pos += sprintf(pos, "Code:%d (0x%X)\n", errorCode, errorCode);
   KpDCPwr_GetError(vi, &errorCode, bufferSize, pos);
   
   // Display the error from the instrument, if that is the source
   if (errorCode == KPDCPWR_ERROR_INSTRUMENT_STATUS)
   {
	   KpDCPwr_error_query(vi, &errorCode, buffer);
   }
   
   MessagePopup("Error!", buffer);
   
   free(buffer);
}
